Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/ssao.cg
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/ssao.cg	(revision 3341)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/shaders/ssao.cg	(revision 3342)
@@ -496,9 +496,8 @@
 	
 	//const float radiusMult = kernelRadius;
-	const float radiusMult = 3e-2;
-	//const float radiusMult = kernelRadius * invw;
-	
-#if 1
-//#ifdef PERFORMANCE_TEST	
+	//const float radiusMult = 3e-2;
+	const float radiusMult = kernelRadius * invw;
+	
+#ifdef PERFORMANCE_TEST	
 
 	float3 diffVec = tex2Dlod(attribsTex, float4(IN.texCoord, 0, 0)).xyz;
@@ -558,6 +557,6 @@
 	}
 
-#if 1
-//#ifdef PERFORMANCE_TEST
+
+#ifdef PERFORMANCE_TEST
 
 	///////////
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/src/DeferredRenderer.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/src/DeferredRenderer.cpp	(revision 3341)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/src/DeferredRenderer.cpp	(revision 3342)
@@ -284,5 +284,4 @@
 static void UpdateSampleTex(Sample2 *samples, int numSamples)
 {
-	PrintGLerror("here4");
 	glEnable(GL_TEXTURE_2D);
 	glBindTexture(GL_TEXTURE_2D, sampleTex2D);
@@ -418,5 +417,5 @@
 	for (int i = 0; i < 4; ++ i)
 	{
-		mIllumFbo->AddColorBuffer(ColorBufferObject::R_FLOAT_32, ColorBufferObject::WRAP_CLAMP_TO_EDGE, ColorBufferObject::FILTER_LINEAR);
+		mIllumFbo->AddColorBuffer(ColorBufferObject::RGBA_FLOAT_32, ColorBufferObject::WRAP_CLAMP_TO_EDGE, ColorBufferObject::FILTER_LINEAR);
 		FrameBufferObject::InitBuffer(mIllumFbo, i);
 	}
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/toto.txt
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/toto.txt	(revision 3340)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/toto.txt	(revision 3342)
@@ -210,8 +210,2 @@
 
 fix normals!!
-
-
-test against old version
-index + Q in same channel
-
-make ambient first then ao then diffuse!!
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/vienna.env
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/vienna.env	(revision 3306)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/vienna.env	(revision 3342)
@@ -110,6 +110,6 @@
 ssaoKernelRadius=4e-1f
 # ssao sample intensity
-#ssaoSampleIntensity=0.2f
-ssaoSampleIntensity=0.8f
+ssaoSampleIntensity=0.2f
+#ssaoSampleIntensity=0.8f
 # ssao temporal coherence factor
 tempCohFactor=2000.0f
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/Converter.vcproj
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/Converter.vcproj	(revision 3334)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/Converter.vcproj	(revision 3342)
@@ -156,5 +156,5 @@
 				AdditionalLibraryDirectories="libs\Zlib\lib"
 				IgnoreDefaultLibraryNames="libCMT"
-				GenerateDebugInformation="true"
+				GenerateDebugInformation="false"
 				SubSystem="1"
 				LargeAddressAware="2"
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/MainApp.vcproj
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/MainApp.vcproj	(revision 3338)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/MainApp.vcproj	(revision 3342)
@@ -156,5 +156,5 @@
 				IgnoreAllDefaultLibraries="false"
 				IgnoreDefaultLibraryNames="LIBCMT"
-				GenerateDebugInformation="true"
+				GenerateDebugInformation="false"
 				SubSystem="1"
 				LargeAddressAware="2"
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/Converter/ObjConverter.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/Converter/ObjConverter.cpp	(revision 3335)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/Converter/ObjConverter.cpp	(revision 3342)
@@ -523,19 +523,15 @@
 	vector<Geometry *>::const_iterator it, it_end = mGeometry.end();
 
-	Material defaultMaterial;
-
 	for (it = mGeometry.begin(); it != it_end; ++ it)
 	{
-
-		///////////////////////
-		//-- write geometry
-
 		WriteGeometry(ofile, *it);
 
 		
 		/////////
-		//-- write material
-
-		Material *mat = (*it)->mMaterial ? (*it)->mMaterial : &defaultMaterial;
+		//-- material
+
+		Material *mat = (*it)->mMaterial;
+
+		if (!mat) cerr << "error: no material specified!!" << endl;
 
 		ofile.write(reinterpret_cast<char *>(&mat->texture), sizeof(int));
@@ -544,5 +540,5 @@
 		//bool cullFaceEnabled = false;
 		bool cullFaceEnabled = true;
-
+		
 		ofile.write(reinterpret_cast<char *>(&alphaTestEnabled), sizeof(bool));
 		ofile.write(reinterpret_cast<char *>(&cullFaceEnabled), sizeof(bool));
@@ -551,10 +547,10 @@
 		bool hasMaterial = true;
 		ofile.write(reinterpret_cast<char *>(&hasMaterial), sizeof(bool));
-
+	
 		SimpleVec ambient, diffuse, spec, emm;
 
 		ambient.x = ambient.y = ambient.z = 0.2f;
 		//diffuse.x = diffuse.y = diffuse.z = 1.0f;
-		diffuse.x = mat->rgb[0]; diffuse.y = mat->rgb[1]; diffuse.z = mat->rgb[2];
+		diffuse.x = mat->rgb[0]; diffuse.y =mat->rgb[1]; diffuse.z = mat->rgb[2];
 		spec.x = spec.y = spec.z = .0f;
 		emm = spec;
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/Converter/ObjConverter2.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/Converter/ObjConverter2.cpp	(revision 3335)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/Converter/ObjConverter2.cpp	(revision 3342)
@@ -486,5 +486,5 @@
 		Material *mat = (*it)->mMaterial;
 
-		if (!mat) cerr << "error: no material associated with this geometry!!" << endl;
+		if (!mat) cerr << "error: no material specified!!" << endl;
 
 		ofile.write(reinterpret_cast<char *>(&mat->texture), sizeof(int));
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/Converter/main.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/Converter/main.cpp	(revision 3334)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/Converter/main.cpp	(revision 3342)
@@ -14,14 +14,11 @@
 
 	cout << "converting obj to dem format" << endl;
-#if 1 // use this path for converting a file with materials
-	if  (argc > 3)
+#if 1
+	if (!converter.LoadMaterials(model_path + argv[3]))
 	{
-		if (!converter.LoadMaterials(model_path + argv[3]))
-		{
-			cerr << "loading materials failed" << endl;
+		cerr << "loading materials failed" << endl;
 
-			std::cin.get();
-			exit(0);
-		}
+		std::cin.get();
+		exit(0);
 	}
 
@@ -33,5 +30,5 @@
 		exit(0);
 	}
-#else // use this bath to convert the pompeii model
+#else
 	
 	//const int numFiles = 879;
Index: GTP/trunk/App/Demos/Vis/FriendlyCulling/sibenik.env
===================================================================
--- GTP/trunk/App/Demos/Vis/FriendlyCulling/sibenik.env	(revision 3323)
+++ GTP/trunk/App/Demos/Vis/FriendlyCulling/sibenik.env	(revision 3342)
@@ -101,8 +101,8 @@
 ssaoUseFullResolution=1
 # ssao kernel radius
-ssaoKernelRadius=2.5f
+ssaoKernelRadius=1.0f
 # ssao sample intensity
-#ssaoSampleIntensity=0.2f
-ssaoSampleIntensity=0.8f
+ssaoSampleIntensity=0.9f
+#ssaoSampleIntensity=0.8f
 # ssao temporal coherence factor
 tempCohFactor=1500.0f